/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_sessiondata
#define headerfile_winix_plugins_ticket_sessiondata

#include <vector>
#include <string>
#include <map>
#include "core/plugindata.h"
#include "ticket.h"
#include "functions/rm.h"


namespace Ticket
{


struct SessionData : public PluginDataBase
{
	SessionData();
	~SessionData();


	typedef std::map<long, Ticket>              TicketMap;
	typedef std::map<long, std::vector<long> >  FileMap;


	// temporary tickets for 'createticket' function
	// <parent_dir_id, Ticket>
	TicketMap create_ticket_map;

	// temporary tickets for 'editticket' function
	// <file_id, Ticket>
	TicketMap edit_ticket_map;


	// temporary files for 'createticket' function
	// these files should be deleted if a user will not click on the submit button
	FileMap create_file_map;

	// temporary files for 'editticket' function
	// these files should be deleted if a user will not click on the submit button
	// !! zmienic nazwe na edit_file_map albo podobnie
	FileMap edit_file_map;


	// inserting and returning a new ticket or just returning the ticket if it exists
	Ticket & GetTicket(long id, TicketMap & ticket_map, bool * is_new = 0);

	std::vector<long> & GetFileTab(long id, FileMap & file_map);

	// for deleting edit_file_map files
	// !! IMPROVE ME: when the program exits there can be a situation that
	// fun_rm was finished and then an object of this class exits and call fun_rm
	// so we should guarantee that all sessions object are removed first
	Fun::Rm * fun_rm;

	void RemoveFileMap(FileMap & file_map);
};


} // namespace


#endif
